#ifndef TOPPERS_TARGET_ASM_INC
#define TOPPERS_TARGET_ASM_INC

.macro my_core_index re_reg sc_reg1
	mrs   \re_reg, mpidr_el1
	and	  \re_reg, \re_reg, #MPIDR_AFF0_MASK
.endm

#ifdef USE_THREAD_ID_PCB
.macro my_pcb re_reg sc_reg1
	mrs   \re_reg, tpidr_el1
.endm
#else  /* USE_THREAD_ID_PCB */
.macro my_pcb re_reg sc_reg1
	mrs   \re_reg, mpidr_el1
	and	  \sc_reg1, \re_reg, #MPIDR_AFF0_MASK
	and	  \re_reg, \re_reg, #MPIDR_AFF1_MASK
	eor	  \re_reg, \re_reg, #(1 << MPIDR_AFF_SHIFT)  // swap A53/A57 order
	add	  \sc_reg1, \sc_reg1, \re_reg, lsr #6
	ldr   \re_reg, =p_pcb_table
	ldr   \re_reg, [\re_reg, \sc_reg1, lsl #3]
.endm
#endif /* USE_THREAD_ID_PCB */

.macro my_istkpt re_reg sc_reg1
	mrs   \sc_reg1, mpidr_el1
	and	  \sc_reg1, \sc_reg1, #MPIDR_AFF0_MASK
	ldr   \re_reg, =_kernel_istkpt_table
	ldr   \re_reg, [\re_reg, \sc_reg1, lsl #3]
.endm

/*
 *  チップ依存モジュール（MPCORE用）
 */
#include "chip_asm.inc"

#endif /* TOPPERS_TARGET_ASM_INC */
